// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004, 29.11.2007

class OrderedListSet extends OrderedSet {

// Attribute (Datenstruktur):

    private OrderedList list;		// speichert die Elemente der Menge

// Konstruktor fuer eine leere Menge:

    OrderedListSet() {
	list = null;
	currentSize = 0;
    }

// Konstruktor, der die Kopie einer Menge liefert:

    // Zuerst ein Konstruktur speziell fuer OrderedListSet:
    public OrderedListSet(OrderedListSet s) {
	list = OrderedList.copyList(s.list);
	currentSize = s.size();
    }

    // Sonst muss sich der Konstruktur wenig effizient auf insertElement
    // abstuetzen:
    public OrderedListSet(Set s) {
	list = null;
	Enumeration enu = s.getEnumeration();
	while (enu.hasMoreElements()) {
	   try {
	      list = OrderedList.insertElement((Comparable) enu.nextElement(), list);
	   }
	   catch (MultipleElementListException e) {
	      // oje, diese Ausnahme darf hier nun wirklich nicht auftreten!
	      System.err.println("Fehler im copy-Konstruktor von OrderedListSet: " + e);
	      System.exit(1);
	   }
	}
	currentSize = s.size();
    }

// sonstige datenstrukturabhaengige Methoden:

    // liefert Enumeration ueber die Menge:
    public Enumeration getEnumeration() {
       return new OrderedListSetEnumeration(list);
    }

    // Einfuegen eines Elementes:
    public void insert(Object o) throws MultipleElementSetException {
        // sttzt sich auf entsprechende Methode von OrderedList:

	try {
	   list = OrderedList.insertElement((Comparable) o, list);
        }
	catch (MultipleElementListException e) {
	   throw new MultipleElementSetException(e.getMessage());
	}

	// Nur wenn tatschlich ein Element eingefgt wird:
	currentSize++;
    }

    // Entfernen eines Elementes:
    public void delete(Object o) throws NotContainsElementSetException {
        // sttzt sich auf entsprechende Methode von OrderedList:

	try {
	   list = OrderedList.deleteElement((Comparable) o, list);
	}
	catch (NotContainsElementListException e) {
	   throw new NotContainsElementSetException("" + e);
	}

	// Nur wenn tatschlich ein Element entfernt wird:
	currentSize--;
    }
}
